package com.example.libtest;

import com.bw.spdev.KeyBoard;
import com.bw.spdev.Ped;
import com.bw.spdev.RspCode;
import com.bw.spdev.SysCmd;
import com.helper.BCDHelper;




import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.EditText;
import android.widget.TextView;

public class Keypad extends Activity {
	private final static String TAG="Keypad";
	private EditText pw;
	private TextView tvPrompt;

	private ReadThread rthr;
	
	private byte[] keyvalue;
	private BCDHelper bcdH;
	Ped ped = Ped.getInstance();

	private class ReadThread extends Thread {
		private boolean mStopRunning = false;

		// private AlertDialog show;
		public void stopRunning() {
			mStopRunning = true;
		}

		public void startRunning() {
			mStopRunning = false;
		}

		public void run()
		{
			super.run();
			byte pinblk[]=new byte[32];
			int ret;
			ret = ped.GetPinBlock(Keypad.this, pw, 1, "0,4,6", "6226095689096634",  null,  0, 30000, pinblk);
			
		}
	};

	private Handler handler1 = new Handler() {
		@Override
		// 当有消息发送出来的时候就执行Handler的这个方法
		public void handleMessage(Message msg) {
			super.handleMessage(msg);
			
			if (msg.what == -5) {
				tvPrompt.setText("Cancel input! Please return to the previous screen。");
				pw.setText("");
				handler1.removeCallbacks(rthr);
				//key.KeyBoard_CloseFunction();
			}
			else if (msg.what == -2) {
				tvPrompt.setText("Key Error! Please return to the previous screen。");
				handler1.removeCallbacks(rthr);
				//key.KeyBoard_CloseFunction();
			}
			else if (msg.what == -1) {
				tvPrompt.setText("User Input Timeout! Please return to the previous screen。");
				handler1.removeCallbacks(rthr);
				//key.KeyBoard_CloseFunction();
			}			
			else if (msg.what == 2) {
				String pinblock = bcdH.bcdToString(keyvalue, 1, keyvalue[0]);
				String pmsg = "User enter the PINBLOCK : " + pinblock+", Please return to the previous screen。";
				tvPrompt.setText(pmsg);
				handler1.removeCallbacks(rthr);
				//key.KeyBoard_CloseFunction();
			}
			else if (msg.what == 1) {
				byte cnt = keyvalue[0];
				String str = new String();
				str = "";
				for (int idx = 0; idx < cnt; idx++){
					str += "*";
				}
				pw.setText(str);
				pw.setSelection(str.length());
				
				tvPrompt.setText("Please enter the 8-digit password, enter at least 4-digit。");
			}
		}
	};
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		Log.e(null,"enter the keydown process");
	    if(keyCode == KeyEvent.KEYCODE_BACK) 
	    { //监控/拦截/屏蔽返回键
	    	if(rthr!=null)
	    		rthr.stopRunning();	

	    	//key.Close();
	    	ped.PedCancleReadKey();
	    	Keypad.this.finish();
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_MENU) 
	    {
	        //监控/拦截菜单键
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_HOME) 
	    {
	        //由于Home键为系统键，此处不能捕获，需要重写onAttachedToWindow()
	    }
	    return super.onKeyDown(keyCode, event);
	}
	
	public void onCreate(Bundle savedInstanceState) {
		Log.i(null, "enter the pw test activity");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_keypad);

		bcdH     = new BCDHelper();
		keyvalue = new byte[32];

		pw = (EditText) findViewById(R.id.editPw);
		tvPrompt = (TextView) findViewById(R.id.txtPrompt);
		
		
		WriteKey();
		rthr  = new ReadThread();
		rthr.startRunning();
		rthr.start();
		
		
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onDestroy()
	 */
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		if(rthr!=null)
			rthr.stopRunning();
		
		try {
			//Log.e(null,"wait press key");
			Thread.currentThread();
			Thread.sleep(500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		ped.PedCancleReadKey();
		super.onDestroy();
		Log.e("","onDestroy ...");
	}
	
	void WriteKey()
	{
		SysCmd sysCmd =SysCmd.getInstance();
		int srcKeyType,srcKeyIdx,dstKeyType,dstKeyIdx,algthflag,dstKeyLen,checkMode;
		byte checkBuf[] = new byte[32];
		int ret;
		//擦除ped
		ret = ped.Erase();
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"Erase ok");
		}
		else
		{
			Log.e(null,"Erase fail");//失败
			ret = sysCmd.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		
		
		/*******************用des算法,写入TMK\TAP\TPK\TDK\TEK\TTK****************************************/
		
		////WriteKey TLK 写入TLK 明文 16 字节密钥 无校验 KEY=0123456789abcdef0011223344556677
		srcKeyType = srcKeyIdx = 0;//写TLK时明文写
		dstKeyType = Ped.PED_TLK;//目标密钥类型为TLK
		dstKeyIdx = 0x01;//当写TLK时密钥索引一定是0x01
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，TLK:16或者24字节
		checkMode = 0;//校验模式，0时不进行校验，后续的校验字节填null
		byte tlkkey[] = {0x01,0x23,0x45,0x67,(byte)0x89,(byte)0xab,(byte)0xcd,(byte)0xef,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
		ret = ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tlkkey, checkMode, 0, null);
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"WriteTlk ok");
		}
		else
		{
			Log.e(null,"WriteTlk fail");//失败
			ret = sysCmd.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		
		//WriteKey TMK 写入TMK 密文 16 字节密钥 有校验 
		//明文KEY=0123456789abcdef0011223344556677
		//用TLK对此KEY进行3DE运算,得到密文key = D81F89CC27EF6025BD86704242F20EF5,将此密文key写入TMK
		srcKeyType = Ped.PED_TLK;//用TLK写TMK
		srcKeyIdx = 0x01;//TLK索引
		dstKeyType = Ped.PED_TMK;//目标密钥类型为TMK
		dstKeyIdx = 0x01;//TMK索引为1~64
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
		checkBuf[0] = 0x2B;
		checkBuf[1] = 0x00;
		checkBuf[2] = (byte)0xDF;
		checkBuf[3] = (byte)0xFD;
		
		byte tmkkey[] = {(byte)0xD8,(byte)0x1F,(byte)0x89,(byte)0xCC,(byte)0x27,(byte)0xEF,(byte)0x60,
						(byte)0x25,(byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,(byte)0x42,(byte)0xF2,
						(byte)0x0E,(byte)0xF5};
		ret = ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tmkkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"WriteTmk ok");
		}
		else
		{
			Log.e(null,"WriteTmk fail");//失败
			ret = sysCmd.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
			
		//WriteKey TPK 写入TPK 密文 16 字节密钥 有校验 
		//明文KEY=1123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = FB4F67AA3DC6384DBD86704242F20EF5,将此密文key写入TPK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TPK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TPK;//目标密钥类型为TPK
		dstKeyIdx = 0x01;//TPK索引为1~64
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
		checkBuf[0] = 0x42;
		checkBuf[1] = 0x3c;
		checkBuf[2] = (byte)0x27;
		checkBuf[3] = (byte)0x17;
		
		byte tpkkey[] = {(byte)0xFB,(byte)0x4F,(byte)0x67,(byte)0xAA,
						 (byte)0x3D,(byte)0xC6,(byte)0x38,(byte)0x4D,
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret = ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tpkkey, checkMode, 4, checkBuf);
		
		
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"WriteTpk ok");
		}
		else
		{
			Log.e(null,"WriteTpk fail");//失败
			ret = sysCmd.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
	}

}
