package com.example.libtest;

import java.util.Arrays;

import com.bw.spdev.IccReader;
import com.bw.spdev.InputPwdDlg;
import com.bw.spdev.Ped;
import com.bw.spdev.RspCode;
import com.bw.spdev.Ped.PwDlgPara;
import com.helper.BCDHelper;
import com.helper.MyHelper;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


public class PinPedDemo extends Activity 
{
	
	Button btnInjectKey,btnGetPinBlockWithTpk,btnGetPinBlockWithTik,btnVerifyPlainPin;
	TextView title;
	InjectKeyThread rth;
	EditText pwdtext;
	public void onCreate(Bundle savedInstanceState) 
	{
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_pinped);

		title = (TextView)findViewById(R.id.pedTitle);
		title.setText(R.string.ped_button);
		btnInjectKey = (Button)findViewById(R.id.btnPedInjectKey);
		btnGetPinBlockWithTpk = (Button)findViewById(R.id.btnGetPinBlockTpk);
		btnGetPinBlockWithTik = (Button)findViewById(R.id.btnGetPinBlockTik);
		btnVerifyPlainPin = (Button)findViewById(R.id.btnPlainPinVerify);
		pwdtext = (EditText)findViewById(R.id.pedPwdEdit);
		pwdtext.setEnabled(false);
		
		btnInjectKey.setText(R.string.ped_injectKey);
		btnGetPinBlockWithTpk.setText(R.string.ped_getPinBlock_tpk);
		btnGetPinBlockWithTik.setText(R.string.ped_getPinBlock_tik);
		btnVerifyPlainPin.setText(R.string.ped_verifyPlainPin);

		ButtonListener listener = new ButtonListener();
		btnInjectKey.setOnClickListener(listener);
		btnVerifyPlainPin.setOnClickListener(listener);
		btnGetPinBlockWithTpk.setOnClickListener(listener);
		btnGetPinBlockWithTik.setOnClickListener(listener);
		
	}
	
	class ButtonListener implements OnClickListener
	{
		int ret ;
		public void onClick(View v)
		{
			switch(v.getId())
			{
			
			case R.id.btnPedInjectKey:
				rth  = new InjectKeyThread();
				rth.startRunning();
				rth.start();
					
				break;
			case R.id.btnGetPinBlockTpk:
				pwdtext.setText("");
				GetPinBlkWithTpkThread GetPinBlkWithTpkthr = new GetPinBlkWithTpkThread();
				GetPinBlkWithTpkthr.startRunning();
				GetPinBlkWithTpkthr.start();
				break;
			case R.id.btnGetPinBlockTik:
				pwdtext.setText("");
				GetPinBlkWithTikThread GetPinBlkWithTikthr = new GetPinBlkWithTikThread();
				GetPinBlkWithTikthr.startRunning();
				GetPinBlkWithTikthr.start();
				break;
				
			case R.id.btnPlainPinVerify:
				pwdtext.setText("");
				VerifyPlainPinThread VerifyPlainPinthr = new VerifyPlainPinThread();
				VerifyPlainPinthr.startRunning();
				VerifyPlainPinthr.start();
				break;
			}

		}
	}
	
	private class VerifyPlainPinThread extends Thread 
	{
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run()
			{
				
				Looper.prepare();
				super.run();
				toVerifyPlainPin();
				Looper.loop();
				rth = null;
			}
	};
	
	void toVerifyPlainPin()
	{
		int ret;
		Bundle bd;
		Message msg;
		int srcKeyType,srcKeyIdx,dstKeyType,dstKeyIdx,algthflag,dstKeyLen,checkMode;
		byte checkBuf[] = new byte[32];
		
		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_injectKey).toString());
		hdMsg.sendMessage(msg);
		//所以先擦除
		PosUtils.ped.Erase();
		
		//写TLK
		byte tlkkey[] = {0x01,0x23,0x45,0x67,(byte)0x89,(byte)0xab,(byte)0xcd,(byte)0xef,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
		
		srcKeyType = srcKeyIdx = 0;//写TLK时明文写
		dstKeyType = Ped.PED_TLK;//目标密钥类型为TLK
		dstKeyIdx = 0x01;//当写TLK时密钥索引一定是0x01
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，TLK:16或者24字节
		checkMode = 0;//校验模式，0时不进行校验，后续的校验字节填null
		
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tlkkey, checkMode, 0, null);
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"WriteTlk ok");
		}
		else
		{
			Log.e(null,"WriteTlk fail");//失败
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		//然后密文写TIK，tik明文为10101010101010101010101010101010
		//用tlk对其进行3des，生成密文:A208B218E0265796A208B218E0265796
		
		int GroupIdx = 1;//DUKPT 组ID,1~10
		int SrcKeyIdx = 1;//密文写,源密钥为TLK
		int KeyLen=16;
		 

		 byte tikkeyenc []={
				 (byte)0xA2,(byte)0x08,(byte)0xB2,(byte)0x18,
				 (byte)0xE0,(byte)0x26,(byte)0x57,(byte)0x96,
				 (byte)0xA2,(byte)0x08,(byte)0xB2,(byte)0x18,
				 (byte)0xE0,(byte)0x26,(byte)0x57,(byte)0x96
		 };
	
		checkMode  = 1;
		
		checkBuf[0] =(byte) 0x82;
		checkBuf[1] =(byte) 0xE1;
		checkBuf[2] = (byte)0x36;
		checkBuf[3] = (byte)0x65;
		
		byte ksn[] = {(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10};
		ret = PosUtils.ped.WriteTIK(GroupIdx, SrcKeyIdx, KeyLen, tikkeyenc, ksn, checkMode, 4, checkBuf);
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		
		/*******************密文写TIK并用TIK生成pinblk,结束**********************/
		
		
		/**************脱机明文pin校验***************/
		
	
		if(PosUtils.icc.Reset()==RspCode.RSPERR)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ic_PlsInsertIc).toString());
			hdMsg.sendMessage(msg);
			return;
		}
		byte IccRespOut[] = new byte[32];
		ret = PosUtils.ped.VerifyPlainPin(PinPedDemo.this ,pwdtext, 0, "0,4,5,6,7,8,9,10,11,12", 0, 30000, IccRespOut);
		
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			Log.e(null,"IccRespOut:"+BCDHelper.bcdToString(IccRespOut, 0, 2*(IccRespOut[0]+1)));
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.KEY_NOICCARD:
			Log.e(null,"NOICCARD ");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		
		PosUtils.icc.Eject();
				
	}
	
	private class InjectKeyThread extends Thread 
	{
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run()
			{
				
				Looper.prepare();
				super.run();
				//toInjectKey();
				toWriteTPKKey();
				Looper.loop();
				rth = null;
			}
	};
	
	
	private class GetPinBlkWithTikThread extends Thread 
	{
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run()
			{
				
				Looper.prepare();
				super.run();
				toGetPinBlkWithTik();
				Looper.loop();
				rth = null;
			}
	};
	
	void toGetPinBlkWithTik()
	{
		int ret;
		Bundle bd;
		Message msg;
		
		
		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_injectKey).toString());
		hdMsg.sendMessage(msg);
		
		
		/*******************明文写TIK并用TIK生成pinblk**********************/
		//明文写TIK：
		//只有在tlk不存在时才可以明文写，所以先擦除
		PosUtils.ped.Erase();
		//然后明文写
		int GroupIdx = 1;//DUKPT 组ID,1~10
		int SrcKeyIdx = 0;//为0表示明文写
		int KeyLen=16;
		byte tikkey[] = {
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10
				};
		byte ksn[] = {(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10};
		byte checkMode  = 0;
		ret = PosUtils.ped.WriteTIK(GroupIdx, SrcKeyIdx, KeyLen, tikkey, ksn, checkMode, 0, null);
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		
		
		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_plsInputPws).toString());
		hdMsg.sendMessage(msg);
		
		byte KsnOut[] = new byte[32];
		byte PinBlockOut[] = new byte[32];
		//byte fmtdata[] = {(byte)0xab,(byte)0xcd,(byte)0xef,(byte)0xab,(byte)0xcd,(byte)0xef,(byte)0xab,(byte)0xcd};
		byte fmtdata[] = {(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00};
		//ret=PosUtils.ped.GetPinblkDukpt(PinPedDemo.this,pwdtext, GroupIdx, "0,4,6","6226096599485045", fmtdata,0,30000,KsnOut, PinBlockOut);
		PosUtils.ped.GetPinblkDukpt(PinPedDemo.this, GroupIdx, "0,4,6","6226096599485045", fmtdata,0,30000,null, KsnOut, PinBlockOut);
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_pinblock).toString()+BCDHelper.bcdToString(PinBlockOut, 0, 2*(PinBlockOut[0]+1)));
			hdMsg.sendMessage(msg);
			MyHelper.sleep_ms(1000);
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_ksn).toString()+BCDHelper.bcdToString(KsnOut, 0, 2*(KsnOut[0]+1)));
			hdMsg.sendMessage(msg);
			
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_userCancle).toString());
			hdMsg.sendMessage(msg);
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		
	}
	
	
	private class GetPinBlkWithTpkThread extends Thread 
	{
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run()
			{
				
				Looper.prepare();
				super.run();
				//toGetPinBlkWithTpk();
				TestGetPinblk();
				Looper.loop();
				rth = null;
			}
	};
	
	void toGetPinBlkWithTpk()
	{
		int ret;
		Bundle bd;
		Message msg;
		
		
//		bd  = new Bundle();
//		msg = new Message();
//		msg.setData(bd);
//		bd.putString("msg", getString(R.string.ped_injectKey).toString());
//		hdMsg.sendMessage(msg);
		
//		int srcKeyType,srcKeyIdx,dstKeyType,dstKeyIdx,algthflag,dstKeyLen,checkMode;
//		byte checkBuf[] = new byte[32];
//		ret = PosUtils.ped.Erase();
//		if(ret==RspCode.RSPOK)
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_eraseOk).toString());
//			hdMsg.sendMessage(msg);
//			Log.e(null,"Erase ok");
//		}
//		else
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_eraseFail).toString());
//			hdMsg.sendMessage(msg);
//			ret = PosUtils.sys.GetLastErrNo();
//			Log.e(null,"ret = "+ret);
//			return;
//		}
//		MyHelper.sleep_ms(1000);
//		
//
//		/*******************用des算法,写入TMK\TAP\TPK\TDK\TEK\TTK****************************************/
//		
//		////WriteKey TLK 写入TLK 明文 16 字节密钥 无校验 KEY=0123456789abcdef0011223344556677
//		srcKeyType = srcKeyIdx = 0;//写TLK时明文写
//		dstKeyType = Ped.PED_TLK;//目标密钥类型为TLK
//		dstKeyIdx = 0x01;//当写TLK时密钥索引一定是0x01
//		algthflag = Ped.Algthflag_DES;//算法标识
//		dstKeyLen = 16;//目标密钥长度，TLK:16或者24字节
//		checkMode = 0;//校验模式，0时不进行校验，后续的校验字节填null
//		byte tlkkey[] = {0x01,0x23,0x45,0x67,(byte)0x89,(byte)0xab,(byte)0xcd,(byte)0xef,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
//		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
//								dstKeyType, dstKeyIdx, 
//								algthflag, dstKeyLen, 
//								tlkkey, checkMode, 0, null);
//		if(ret==RspCode.RSPOK)
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTlkOk).toString());
//			hdMsg.sendMessage(msg);
//			Log.e(null,"Erase ok");
//		}
//		else
//		{
//			
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTlkFail).toString());
//			hdMsg.sendMessage(msg);
//			ret = PosUtils.sys.GetLastErrNo();
//			Log.e(null,"ret = "+ret);
//			return;
//		}
//		MyHelper.sleep_ms(2000);
//		
//		//WriteKey TMK 写入TMK 密文 16 字节密钥 有校验 
//		//明文KEY=0123456789abcdef0011223344556678
//		//用TLK对此KEY进行3DE运算,得到密文key = D81F89CC27EF60251C80782CD3ED9B8A,将此密文key写入TMK
//		srcKeyType = Ped.PED_TLK;//用TLK写TMK
//		srcKeyIdx = 0x01;//TLK索引
//		dstKeyType = Ped.PED_TMK;//目标密钥类型为TMK
//		dstKeyIdx = 0x01;//TMK索引为1~64
//		algthflag = Ped.Algthflag_DES;//算法标识
//		dstKeyLen = 16;//目标密钥长度，
//		checkMode = 1;//校验模式，有校验,
//		checkBuf[0] = (byte) 0xEE;
//		checkBuf[1] = (byte) 0xE3;
//		checkBuf[2] = (byte)0xDB;
//		checkBuf[3] = (byte)0x73;
//		
//		byte tmkkey[] = 
//		{(byte)0xD8,(byte)0x1F,(byte)0x89,(byte)0xCC,(byte)0x27,(byte)0xEF,(byte)0x60,(byte)0x25,
//		(byte)0x1C,(byte)0x80,(byte)0x78,(byte)0x2C,(byte)0xD3,(byte)0xED,(byte)0x9B,(byte)0x8A};
//		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
//								dstKeyType, dstKeyIdx, 
//								algthflag, dstKeyLen, 
//								tmkkey, checkMode, 4, checkBuf);
//		if(ret==RspCode.RSPOK)
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTmkOk).toString());
//			hdMsg.sendMessage(msg);
//			Log.e(null,"Erase ok");
//		}
//		else
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTmkFail).toString());
//			hdMsg.sendMessage(msg);
//			ret = PosUtils.sys.GetLastErrNo();
//			Log.e(null,"ret = "+ret);
//			return;
//		}
//		MyHelper.sleep_ms(2000);
//			
//		//WriteKey TPK 写入TPK 密文 16 字节密钥 有校验 
//		//明文KEY=1123456789abcdef0011223344556677
//		//用TMK对此密钥进行3DES加密,得到密文key = 69BF52CA01F1AD3D7E91F82EE28A2FE4,将此密文key写入TPK
//		
//		srcKeyType = Ped.PED_TMK;//用TMK写TPK
//		srcKeyIdx = 0x01;//TMK索引
//		dstKeyType = Ped.PED_TPK;//目标密钥类型为TPK
//		dstKeyIdx = 0x01;//TPK索引为1~64
//		algthflag = Ped.Algthflag_DES;//算法标识
//		dstKeyLen = 16;//目标密钥长度，
//		checkMode = 1;//校验模式，有校验,
//		checkBuf[0] = 0x42;
//		checkBuf[1] = 0x3c;
//		checkBuf[2] = (byte)0x27;
//		checkBuf[3] = (byte)0x17;
//		
//		byte tpkkey[] = 
//			{
//				(byte)0x69,(byte)0xBF,(byte)0x52,(byte)0xCA,(byte)0x01,(byte)0xF1,(byte)0xAD,
//				(byte)0x3D,(byte)0x7E,(byte)0x91,(byte)0xF8,(byte)0x2E,(byte)0xE2,(byte)0x8A,
//				(byte)0x2F,(byte)0xE4
//			};
//			
//		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
//								dstKeyType, dstKeyIdx, 
//								algthflag, dstKeyLen, 
//								tpkkey, checkMode, 4, checkBuf);
//		
//		
//		if(ret==RspCode.RSPOK)
//		{
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTpkOk).toString());
//			hdMsg.sendMessage(msg);
//			Log.e(null,"Erase ok");
//		}
//		else
//		{
//			
//			bd  = new Bundle();
//			msg = new Message();
//			msg.setData(bd);
//			bd.putString("msg", getString(R.string.ped_injectTpkFail).toString());
//			hdMsg.sendMessage(msg);
//			ret = PosUtils.sys.GetLastErrNo();
//			Log.e(null,"ret = "+ret);
//			return;
//		}
//		MyHelper.sleep_ms(2000);
		
		
		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_plsInputPws).toString());
		hdMsg.sendMessage(msg);
		
		
		
		//用tpk进行getpinblk操作
		byte plk[] = new byte[32];
		ret  = PosUtils.ped.GetPinBlock(PinPedDemo.this,pwdtext, 1, "0,4,5,6,7,8,9,10,11,12", "6226095689096634",  null,  0, 30000, plk);
		//ret  = PosUtils.ped.GetPinBlock(PinPedDemo.this, 1, "0,4,5,6,7,8,9,10,11,12", "6226095689096634",  null,  0, 30000, null, plk);
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			Log.e(null,"tpk pinblk:"+BCDHelper.bcdToString(plk, 0, plk[0]+1));
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_pinblock).toString()+BCDHelper.bcdToString(plk, 0, 2*(plk[0]+1)));
			hdMsg.sendMessage(msg);
			
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_userCancle).toString());
			hdMsg.sendMessage(msg);
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		
	}
	void TestGetPinblk(){
		//toWriteKey();
		
		//byte[] b = new byte[64];
		String cardNum = "4392220035809564";		
		int iret = PosUtils.ped.PedGetPinBlkInit(1, "0,4,5,6,7,8,9,10,11,12",
				cardNum, null, 0, 30000);
		
		Log.d("","PedGetPinBlkInit="+iret);
		if (iret<0) {
			AlertDialog.Builder builder = new Builder(PinPedDemo.this);
			builder.setTitle("输入密码准备出错，中断输入过程");
			builder.show();
		} else {
			PwDlgPara para=null;	//new PwDlgPara();
			//para.
			InputPwdDlg tp = new InputPwdDlg(PinPedDemo.this, "请输密码", "", para);
			tp.showDialog();
			if (tp.getDialogResult()==RspCode.RSPOK) {
				;//从  Util 里反射后读取到 PINBLK
			}
		}
	}
	
	
	
	private Handler hdMsg =new Handler()
	{
	   @Override
	   //当有消息发送出来的时候就执行Handler的这个方法
	   public void handleMessage(Message msg)
	   {
	      super.handleMessage(msg);
	      String sMsg  = msg.getData().getString("msg");
	      Toast.makeText(PinPedDemo.this, 
					 sMsg, 0).show(); 
	   }
	};
	
	//zhanghw,2015-09-02,add,仅测试用，写入TPK，一般只写一遍就行了。
	int toWriteTPKKey() {
		//Toast.makeText(getApplicationContext(), "写密钥中...", (int)3000).show();
		Bundle bd;
		Message msg;
		
		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_injectTpking).toString());
		hdMsg.sendMessage(msg);
		Log.e(null,"Write TPK  ...");
		
		byte bufIn[] = new byte[64];
		Arrays.fill(bufIn, (byte) 0xff);
		bufIn = BCDHelper.StrToBCD("625D7E1DF0284A843BD3C89CB9A01764", 32);
		
		PosUtils.ped.Erase();
		int ret = PosUtils.ped.WriteKey(0, 0, Ped.PED_TPK, 0x01, Ped.Algthflag_DES, 16,
				bufIn, 0, 0, null);
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTpkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Write TPK ok");
		}
		else
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTpkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"Write TPK ret = "+ret);
			return -1;
		}
		MyHelper.sleep_ms(2000);
		return 0;
	}
	
	void toInjectKey()
	{
		int ret;
		Bundle bd;
		Message msg;
		int srcKeyType,srcKeyIdx,dstKeyType,dstKeyIdx,algthflag,dstKeyLen,checkMode;
		byte checkBuf[] = new byte[32];
		ret = PosUtils.ped.Erase();
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_eraseOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_eraseFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		

		/*******************用des算法,写入TMK\TAP\TPK\TDK\TEK\TTK****************************************/
		
		////WriteKey TLK 写入TLK 明文 16 字节密钥 无校验 KEY=0123456789abcdef0011223344556677
		srcKeyType = srcKeyIdx = 0;//写TLK时明文写
		dstKeyType = Ped.PED_TLK;//目标密钥类型为TLK
		dstKeyIdx = 0x01;//当写TLK时密钥索引一定是0x01
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，TLK:16或者24字节
		checkMode = 0;//校验模式，0时不进行校验，后续的校验字节填null
		byte tlkkey[] = {0x01,0x23,0x45,0x67,(byte)0x89,(byte)0xab,(byte)0xcd,(byte)0xef,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tlkkey, checkMode, 0, null);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTlkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTlkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		
		//WriteKey TMK 写入TMK 密文 16 字节密钥 有校验 
		//明文KEY=0123456789abcdef0011223344556677
		//用TLK对此KEY进行3DE运算,得到密文key = D81F89CC27EF6025BD86704242F20EF5,将此密文key写入TMK
		srcKeyType = Ped.PED_TLK;//用TLK写TMK
		srcKeyIdx = 0x01;//TLK索引
		dstKeyType = Ped.PED_TMK;//目标密钥类型为TMK
		dstKeyIdx = 0x01;//TMK索引为1~64
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
		checkBuf[0] = 0x2B;
		checkBuf[1] = 0x00;
		checkBuf[2] = (byte)0xDF;
		checkBuf[3] = (byte)0xFD;
		
		byte tmkkey[] = {(byte)0xD8,(byte)0x1F,(byte)0x89,(byte)0xCC,(byte)0x27,(byte)0xEF,(byte)0x60,
						(byte)0x25,(byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,(byte)0x42,(byte)0xF2,
						(byte)0x0E,(byte)0xF5};
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tmkkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTmkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTmkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
			
		//WriteKey TPK 写入TPK 密文 16 字节密钥 有校验 
		//明文KEY=1123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = FB4F67AA3DC6384DBD86704242F20EF5,将此密文key写入TPK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TPK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TPK;//目标密钥类型为TPK
		dstKeyIdx = 0x01;//TPK索引为1~64
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
		checkBuf[0] = 0x42;
		checkBuf[1] = 0x3c;
		checkBuf[2] = (byte)0x27;
		checkBuf[3] = (byte)0x17;
		
		byte tpkkey[] = {(byte)0xFB,(byte)0x4F,(byte)0x67,(byte)0xAA,
						 (byte)0x3D,(byte)0xC6,(byte)0x38,(byte)0x4D,
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tpkkey, checkMode, 4, checkBuf);
		
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTpkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTpkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		/*
		Ped.PwDlgPara para = new Ped.PwDlgPara();
		para.dlgBakGroundResId = R.drawable.t1;
		para.dlgHeight = 100;
		para.titlecolor = Color.rgb(100,200,123);
		para.titleSize = 14;
		para.dlgWidth = 100;
		para.titleLeftMargin=50;
		para.titleTopMargin=25;
		para.pwLeftMargin = 30;
		para.pwTopMargin=para.titleTopMargin+15;
		para.pwSize=50;
		para.pwBold=false;
		para.pwPosition=0;
		para.pwEditWidth=300;
		para.pwTextClr = Color.rgb(0,0,0);
		
		
		//用tpk进行getpinblk操作
		byte plk[] = new byte[32];
		ret  = PosUtils.ped.GetPinBlock(getApplication(), 1, "0,4,6", "6226095689096634",  null,  0, 30000,para, plk);
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			
			Log.e(null,"tpk pinblk:"+BCDHelper.bcdToString(plk, 0, plk[0]+1));
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		*/
		
		
		//WriteKey TAK 写入TAK 密文 16 字节密钥 有校验
		//明文KEY=2123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = 07C859A82E96E249BD86704242F20EF5,将此密文key写入TAK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TPK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TAK;//目标密钥类型为TAK
		dstKeyIdx = 0x02;//索引为1~64,注意用同样密钥索引的TMK生成的PED_TPK、PED_TAK、PED_TDK、PED_TEK、PED_TTK,索引号不能相同
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
		
		checkBuf[0] =(byte) 0x9A;
		checkBuf[1] =(byte) 0xE9;
		checkBuf[2] = (byte)0x62;
		checkBuf[3] = (byte)0xEC;
		
		byte takkey[] = {(byte)0x07,(byte)0xC8,(byte)0x59,(byte)0xA8,
						 (byte)0x2E,(byte)0x96,(byte)0xE2,(byte)0x49,
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								takkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTakOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTakFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		
		MyHelper.sleep_ms(2000);

		//WriteKey TDK 写入TDK 密文 16 字节密钥 有校验
		//明文KEY=3123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = 33873118E621F42FBD86704242F20EF5,将此密文key写入TAK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TDK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TDK;//目标密钥类型为TDK
		dstKeyIdx = 0x03;//索引为1~64,注意用同样密钥索引的TMK生成的PED_TPK、PED_TAK、PED_TDK、PED_TEK、PED_TTK,索引号不能相同
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
	
		checkBuf[0] =(byte) 0x6B;
		checkBuf[1] =(byte) 0x66;
		checkBuf[2] = (byte)0x3A;
		checkBuf[3] = (byte)0xBD;
		
		byte tdkkey[] = {(byte)0x33,(byte)0x87,(byte)0x31,(byte)0x18,
						(byte)0xE6,(byte)0x21,(byte)0xF4,(byte)0x2F,
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tdkkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTdkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTdkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		
		MyHelper.sleep_ms(2000);
		//WriteKey TEK 写入TEK 密文 16 字节密钥 有校验
		//明文KEY=4123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = D95FB3588F652F07BD86704242F20EF5,将此密文key写入TEK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TeK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TEK;//目标密钥类型为TEK
		dstKeyIdx = 0x04;//索引为1~64,注意用同样密钥索引的TMK生成的PED_TPK、PED_TAK、PED_TDK、PED_TEK、PED_TTK,索引号不能相同
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,

		checkBuf[0] =(byte) 0xFD;
		checkBuf[1] =(byte) 0xDD;
		checkBuf[2] = (byte)0xDA;
		checkBuf[3] = (byte)0x72;
		
		byte tekkey[] = {(byte)0xD9,(byte)0x5F,(byte)0xB3,(byte)0x58,
						 (byte)0x8F,(byte)0x65,(byte)0x2F,(byte)0x07,
						
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret =PosUtils. ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tekkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTekOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTekFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		
		MyHelper.sleep_ms(2000);
		//WriteKey TTK 写入TTK 密文 16 字节密钥 有校验
		//明文KEY=5123456789abcdef0011223344556677
		//用TMK对此密钥进行3DES加密,得到密文key = 0CDB7E4C8AB27369BD86704242F20EF5,将此密文key写入TTK
		
		srcKeyType = Ped.PED_TMK;//用TMK写TTK
		srcKeyIdx = 0x01;//TMK索引
		dstKeyType = Ped.PED_TTK;//目标密钥类型为TTK
		dstKeyIdx = 0x05;//索引为1~64,注意用同样密钥索引的TMK生成的PED_TPK、PED_TAK、PED_TDK、PED_TEK、PED_TTK,索引号不能相同
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，
		checkMode = 1;//校验模式，有校验,
	
		
		checkBuf[0] =(byte) 0x86;
		checkBuf[1] =(byte) 0xAE;
		checkBuf[2] = (byte)0x4A;
		checkBuf[3] = (byte)0xF1;
		
		byte ttkkey[] = {(byte)0X0C,(byte)0xDB,(byte)0x7E,(byte)0x4C,
						 (byte)0x8A,(byte)0xB2,(byte)0x73,(byte)0x69,
						
						 (byte)0xBD,(byte)0x86,(byte)0x70,(byte)0x42,
						 (byte)0x42,(byte)0xF2,(byte)0x0E,(byte)0xF5};
		
		ret =PosUtils. ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								ttkkey, checkMode, 4, checkBuf);
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTtkOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTtkFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		/*********用des算法,写入TMK\TAP\TPK\TDK\TEK\TTK  结束**************/
		
		
		/*******************明文写TIK并用TIK生成pinblk**********************/
		//明文写TIK：
		//只有在tlk不存在时才可以明文写，所以先擦除
		PosUtils.ped.Erase();
		//然后明文写
		int GroupIdx = 1;//DUKPT 组ID,1~10
		int SrcKeyIdx = 0;//为0表示明文写
		int KeyLen=16;
		byte tikkey[] = {
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10
				};
		byte ksn[] = {(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10,(byte)0X10,(byte)0X10,
				(byte)0X10,(byte)0X10};
		checkMode  = 0;
		ret = PosUtils.ped.WriteTIK(GroupIdx, SrcKeyIdx, KeyLen, tikkey, ksn, checkMode, 0, null);
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		
		/*
		byte KsnOut[] = new byte[32];
		byte PinBlockOut[] = new byte[32];
		//byte fmtdata[] = {(byte)0xab,(byte)0xcd,(byte)0xef,(byte)0xab,(byte)0xcd,(byte)0xef,(byte)0xab,(byte)0xcd};
		byte fmtdata[] = {(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00};
		ret=PosUtils.ped.GetPinblkDukpt(MainActivity.this, GroupIdx, "0,4,6","6226096599485045", fmtdata,0,12000, para,KsnOut, PinBlockOut);
		
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			Log.e(null,"ksn:"+BCDHelper.bcdToString(KsnOut, 0, KsnOut[0]+1));
			Log.e(null,"pinblk:"+BCDHelper.bcdToString(PinBlockOut, 0, PinBlockOut[0]+1));
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		*/
		/*******************明文写TIK并用TIK生成pinblk,结束**********************/
		
		/*******************密文写TIK并用TIK生成pinblk********************************/
		
		//所以先擦除
		PosUtils.ped.Erase();
		
		//写TLK
	
		srcKeyType = srcKeyIdx = 0;//写TLK时明文写
		dstKeyType = Ped.PED_TLK;//目标密钥类型为TLK
		dstKeyIdx = 0x01;//当写TLK时密钥索引一定是0x01
		algthflag = Ped.Algthflag_DES;//算法标识
		dstKeyLen = 16;//目标密钥长度，TLK:16或者24字节
		checkMode = 0;//校验模式，0时不进行校验，后续的校验字节填null
		
		ret = PosUtils.ped.WriteKey(srcKeyType, srcKeyIdx, 
								dstKeyType, dstKeyIdx, 
								algthflag, dstKeyLen, 
								tlkkey, checkMode, 0, null);
		if(ret==RspCode.RSPOK)
		{
			Log.e(null,"WriteTlk ok");
		}
		else
		{
			Log.e(null,"WriteTlk fail");//失败
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		//然后密文写TIK，tik明文为10101010101010101010101010101010
		//用tlk对其进行3des，生成密文:A208B218E0265796A208B218E0265796
		 GroupIdx = 1;//DUKPT 组ID,1~10
		 SrcKeyIdx = 1;//密文写,源密钥为TLK
		 KeyLen=16;
		 

		 byte tikkeyenc []={
				 (byte)0xA2,(byte)0x08,(byte)0xB2,(byte)0x18,
				 (byte)0xE0,(byte)0x26,(byte)0x57,(byte)0x96,
				 (byte)0xA2,(byte)0x08,(byte)0xB2,(byte)0x18,
				 (byte)0xE0,(byte)0x26,(byte)0x57,(byte)0x96
		 };
	
		checkMode  = 1;
		
		checkBuf[0] =(byte) 0x82;
		checkBuf[1] =(byte) 0xE1;
		checkBuf[2] = (byte)0x36;
		checkBuf[3] = (byte)0x65;
		ret = PosUtils.ped.WriteTIK(GroupIdx, SrcKeyIdx, KeyLen, tikkeyenc, ksn, checkMode, 4, checkBuf);
		
		if(ret==RspCode.RSPOK)
		{
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikOk).toString());
			hdMsg.sendMessage(msg);
			Log.e(null,"Erase ok");
		}
		else
		{
			
			bd  = new Bundle();
			msg = new Message();
			msg.setData(bd);
			bd.putString("msg", getString(R.string.ped_injectTikFail).toString());
			hdMsg.sendMessage(msg);
			ret = PosUtils.sys.GetLastErrNo();
			Log.e(null,"ret = "+ret);
			return;
		}
		MyHelper.sleep_ms(2000);
		/*
		ret=PosUtils.ped.GetPinblkDukpt(MainActivity.this, GroupIdx, "0,4,6","6226096599485045", fmtdata,0,12000, para,KsnOut, PinBlockOut);
		
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			Log.e(null,"ksn:"+BCDHelper.bcdToString(KsnOut, 0, KsnOut[0]+1));
			Log.e(null,"pinblk:"+BCDHelper.bcdToString(PinBlockOut, 0, PinBlockOut[0]+1));
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		
		*/
		/*******************密文写TIK并用TIK生成pinblk,结束**********************/
		
		
		/**************脱机明文pin校验***************/
		/*
		IccReader icc = new IccReader();
		icc.Reset();
		byte IccRespOut[] = new byte[32];
		ret = PosUtils.ped.VerifyPlainPin(MainActivity.this , 0, "0,4,6,8", 0, 120000, 1, para,IccRespOut);
		
		switch(ret)
		{
		case RspCode.KEY_OK://用户按下了确认键
			Log.e(null,"enter key pressed");
			Log.e(null,"IccRespOut:"+BCDHelper.bcdToString(IccRespOut, 0, IccRespOut[0]+1));
			break;
		case RspCode.KEY_CANCEL://用户按下了取消键
			Log.e(null,"cacel key pressed");
			break;
		case RspCode.KEY_OKDIRECT://用户直接按下了确认键
			Log.e(null,"direct enter key pressed");
			break;
		case RspCode.KEY_NOICCARD:
			Log.e(null,"NOICCARD ");
			break;
		case RspCode.RSPERR:
			Log.e(null,"RSPERR,errno is "+PosUtils.sys.GetLastErrNo());
			break;
		default:
			Log.e(null,"err is "+ret);
			break;
		}
		
		icc.Eject();
		*/
		/********获取随机数*******/
		byte random[] = new byte[32];
		ret = PosUtils.ped.GetRandom(8, random);
		Log.e(null,"random:"+BCDHelper.bcdToString(random, 0, ret));

		bd  = new Bundle();
		msg = new Message();
		msg.setData(bd);
		bd.putString("msg", getString(R.string.ped_injectKeyFinish).toString());
		hdMsg.sendMessage(msg);
		
		
	}
	
}
