package com.example.libtest;

import java.io.UnsupportedEncodingException;

import com.bw.spdev.MagCard;
import com.bw.spdev.RspCode;
import com.bw.spdev.SysCmd;
import com.helper.MyHelper;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.EditText;
import android.widget.TextView;

public class SwipeCard extends Activity {
	
	private EditText Stript1, Stript2, Stript3;
	private TextView tvPrompt,tvOutPut,st1,st2,st3;
	private int loop;
	private ReadThread rthr;

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_swipecard);
		
		Stript1 = (EditText)findViewById(R.id.editText_strip1);
		Stript2 = (EditText)findViewById(R.id.editText_strip2);
		Stript3 = (EditText)findViewById(R.id.editText_strip3);
		tvOutPut= (TextView)findViewById(R.id.textView_output);
		
		tvPrompt = (TextView)findViewById(R.id.magTitle);

		st1 = (TextView)findViewById(R.id.textView_mag1);
		st2 = (TextView)findViewById(R.id.textView_mag2);
		st3 = (TextView)findViewById(R.id.textView_mag3);
		
		st1.setText(R.string.mag_Strip1);
		st2.setText(R.string.mag_Strip2);
		st3.setText(R.string.mag_Strip3);
		
		tvPrompt.setText(R.string.mag_Button);
		tvOutPut.setText("");

		rthr = null;
		rthr = new ReadThread();
		
		//初始化磁条卡设备
		int ret = PosUtils.mag.InitDev();
		if (ret == RspCode.RSPERR) 
		{
			rthr.stopRunning();	
			tvOutPut.setText(R.string.mag_InitError);
		} 
		else 
		{
			rthr.startRunning(); 
			rthr.start();
			tvOutPut.setText(R.string.mag_Swip);
		}
	}


	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		Log.e(null,"enter the keydown process");
	    if(keyCode == KeyEvent.KEYCODE_BACK) 
	    { //监控/拦截/屏蔽返回键
	    	if(rthr!=null)
	    		rthr.stopRunning();
	    	MyHelper.sleep_ms(100);
	    	PosUtils.mag.CancelDev();
	   	 	SwipeCard.this.finish();
	       
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_MENU) 
	    {
	        //监控/拦截菜单键
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_HOME) 
	    {
	        //由于Home键为系统键，此处不能捕获，需要重写onAttachedToWindow()
	    }
	    return super.onKeyDown(keyCode, event);
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onDestroy()
	 */
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		
		if(rthr!=null)
		{
			rthr.stopRunning();
			handler1.removeCallbacks(rthr);
		}
		PosUtils.mag.CancelDev();   //关闭磁条卡设备
		super.onDestroy();
	}

	private class ReadThread extends Thread {
		private boolean mStopRunning = false;

		public void stopRunning() {
			mStopRunning = true;
		}

		public void startRunning() {
			mStopRunning = false;
		}

		public void run() {
			super.run();
			
			while (!mStopRunning) {
				int flag = 0;

				//loop = 60;
				while (true) {
					
					if(mStopRunning == true)
						break;
					//检查是否有刷卡动作
					if (PosUtils.mag.CheckDev() == RspCode.RSPOK) {
						//有刷卡
						flag = 1;
						break;
					}
					try 
					{
						//循环等待
						Thread.currentThread();
						Thread.sleep(500);
					} catch (InterruptedException e) 
					{
						e.printStackTrace();
					}
				}
				stopRunning();
				handler1.sendEmptyMessage(flag);
				rthr.interrupt();
				rthr = null;
			}
		}
	};

	private Handler handler1 = new Handler() {
		@Override
		// 当有消息发送出来的时候就执行Handler的这个方法
		public void handleMessage(Message msg) {
			super.handleMessage(msg);
			
			handler1.removeCallbacks(rthr);
			
			if (msg.what == 0) 
			{
				tvOutPut.setText("No credit card or card failure is detected!");
				
			} 
			else if (msg.what == 1) 
			{
				//读3个磁道的信息
				byte[] info1 = new byte[256];
				byte[] info2 = new byte[256];
				byte[] info3 = new byte[256];
				int len1 = PosUtils.mag.GetSingleStripInfo(1, info1);
				int len2 = PosUtils.mag.GetSingleStripInfo(2, info2);
				int len3 = PosUtils.mag.GetSingleStripInfo(3, info3);

				try {
					if (len1 > 0) {
						//1磁道信息
						String str1 = new String(info1, "ISO-8859-1");
						Stript1.setText(str1);
					}
					if (len2 > 0) {
						//2磁道信息
						String str2 = new String(info2, "ISO-8859-1");
						Stript2.setText(str2);
					}
					if (len3 > 0) {
						//3磁道信息
						String str3 = new String(info3, "ISO-8859-1");
						Stript3.setText(str3);
					}
					
					if (len1 > 0 || len2 > 0 || len3 > 0) 
					{
						tvOutPut.setText(R.string.mag_SwipOk);
					} 
					else 
					{
						tvOutPut.setText(R.string.mag_ReadStripError);
						MyHelper.sleep_ms(100);
						if(rthr!=null)
							MyHelper.sleep_ms(500);
						rthr = new ReadThread();
						rthr.startRunning();
						rthr.start();
						return;

					}
					
					
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}			
		}
	};
}
